# coding: utf-8

"""
    Quetzal API

    Quetzal: an API to manage data files and their associated metadata.  # noqa: E501

    OpenAPI spec version: 0.5.0
    Contact: support@quetz.al
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six


class QueryNoResults(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'dialect': 'str',
        'id': 'int',
        'query': 'str',
        'workspace_id': 'int'
    }

    attribute_map = {
        'dialect': 'dialect',
        'id': 'id',
        'query': 'query',
        'workspace_id': 'workspace_id'
    }

    def __init__(self, dialect=None, id=None, query=None, workspace_id=None):  # noqa: E501
        """QueryNoResults - a model defined in OpenAPI"""  # noqa: E501

        self._dialect = None
        self._id = None
        self._query = None
        self._workspace_id = None
        self.discriminator = None

        self.dialect = dialect
        self.id = id
        self.query = query
        if workspace_id is not None:
            self.workspace_id = workspace_id

    @property
    def dialect(self):
        """Gets the dialect of this QueryNoResults.  # noqa: E501

        Dialect of the query.  Use \"postgresql\" for queries that are written in PostgresSQL. For these queries, there will be one table per family, with as many columns as there are keys in each family.  Use \"postgresql_json\" for queries thar are written in PostgresSQL. For this particular case, there will be one unique table called metadata that has an id column and a column for each family.  # noqa: E501

        :return: The dialect of this QueryNoResults.  # noqa: E501
        :rtype: str
        """
        return self._dialect

    @dialect.setter
    def dialect(self, dialect):
        """Sets the dialect of this QueryNoResults.

        Dialect of the query.  Use \"postgresql\" for queries that are written in PostgresSQL. For these queries, there will be one table per family, with as many columns as there are keys in each family.  Use \"postgresql_json\" for queries thar are written in PostgresSQL. For this particular case, there will be one unique table called metadata that has an id column and a column for each family.  # noqa: E501

        :param dialect: The dialect of this QueryNoResults.  # noqa: E501
        :type: str
        """
        if dialect is None:
            raise ValueError("Invalid value for `dialect`, must not be `None`")  # noqa: E501
        allowed_values = ["postgresql", "postgresql_json"]  # noqa: E501
        if dialect not in allowed_values:
            raise ValueError(
                "Invalid value for `dialect` ({0}), must be one of {1}"  # noqa: E501
                .format(dialect, allowed_values)
            )

        self._dialect = dialect

    @property
    def id(self):
        """Gets the id of this QueryNoResults.  # noqa: E501

        Query identifier  # noqa: E501

        :return: The id of this QueryNoResults.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this QueryNoResults.

        Query identifier  # noqa: E501

        :param id: The id of this QueryNoResults.  # noqa: E501
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def query(self):
        """Gets the query of this QueryNoResults.  # noqa: E501

        Query in code as needed by the dialect  # noqa: E501

        :return: The query of this QueryNoResults.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this QueryNoResults.

        Query in code as needed by the dialect  # noqa: E501

        :param query: The query of this QueryNoResults.  # noqa: E501
        :type: str
        """
        if query is None:
            raise ValueError("Invalid value for `query`, must not be `None`")  # noqa: E501

        self._query = query

    @property
    def workspace_id(self):
        """Gets the workspace_id of this QueryNoResults.  # noqa: E501

        Workspace identifier where the query operates  # noqa: E501

        :return: The workspace_id of this QueryNoResults.  # noqa: E501
        :rtype: int
        """
        return self._workspace_id

    @workspace_id.setter
    def workspace_id(self, workspace_id):
        """Sets the workspace_id of this QueryNoResults.

        Workspace identifier where the query operates  # noqa: E501

        :param workspace_id: The workspace_id of this QueryNoResults.  # noqa: E501
        :type: int
        """

        self._workspace_id = workspace_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryNoResults):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
